#------------------------------------------------------------------------------
#
#   Commandophone - MIDI
#
#------------------------------------------------------------------------------

from pygame import midi
from albow.dialogs import Dialog, alert
from albow.controls import Label, Button
from albow.layout import Row, Column
from controls import ListBox

#------------------------------------------------------------------------------

def find_output_devices():
	result = []
	for i in xrange(midi.get_count()):
		info = midi.get_device_info(i)
		#print info ###
		name = info[1]
		is_output = info[3]
		if is_output:
			result.append((i, name))
	return result

def all_sound_off(device):
	for channel in xrange(16):
		device.write_short(0xb0 + channel, 120, 0)

def open_output_device():
	devices = find_output_devices()
	if not devices:
		alert("No MIDI output devices found.")
		return
	dlog = Dialog()
	caption = Label("Select Output Device")
	box = ListBox([device[1] for device in devices])
	buttons = Row([
		Button("OK", action = dlog.ok),
		Button("Cancel", action = dlog.cancel)
	])
	contents = Column([
		Column([caption, box], align = 'l'),
		buttons,
	], align = 'r')
	contents.topleft = (20, 20)
	dlog.add(contents)
	dlog.shrink_wrap()
	if dlog.present():
		device_no = devices[box.value][0]
		return midi.Output(device_no)

#------------------------------------------------------------------------------

midi.init()
